#include "config.h"
#include "rtp.h"

#pragma pack(1)

typedef struct
{
#if	__BYTE_ORDER == __BIG_ENDIAN
	unsigned char version:2;
	unsigned char padding:1;
	unsigned char extension:1;
	unsigned char cc:4;
	unsigned char marker:1;
	unsigned char payload:7;
#else
	unsigned char cc:4;
	unsigned char extension:1;
	unsigned char padding:1;
	unsigned char version:2;
	unsigned char payload:7;
	unsigned char marker:1;
#endif
	unsigned short sequence;
	unsigned long timestamp;
	unsigned long sources[1];	
} RTPHeader;

#pragma pack()

class RTPPacket
{
private:
	friend class RTPQueue;

	RTPPacket *next, *prev;
	unsigned char *buffer;
	unsigned size;

	inline RTPHeader *getHeader(void)
		{return (RTPHeader *)buffer;};

	unsigned getHeaderSize(void);
	unsigned getPayloadSize(void);

	unsigned char *getPayload(void);

	RTPPacket(RTPHeader *header, unsigned char *data, unsigned len);
	~RTPPacket();
};	
	
